/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.collections.adapters;

import java.util.Iterator;

/**
 * Adapts Iterator&lt;E1&gt; to Iterator&lt;E2&gt; using conversion function
 * convert 
 * @author borisman
 */
public abstract class IteratorAdapter<E1, E2> implements Iterator<E2> {

	private final Iterator<E1> backend;
	
	public IteratorAdapter(final Iterator<E1> backend) {
		this.backend = backend;
	}
	
	@Override public boolean hasNext() {
		return backend.hasNext();
	}

	@Override public E2 next() {
		return convert(backend.next());
	}

	@Override public void remove() {
		backend.remove();
	}

	protected abstract E2 convert(final E1 e);
}
