/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.collections.testlist;

import java.util.ArrayList;
import java.util.List;

import org.builtu.collections.testlist.AbstractTestDynamicList;


public class TestDynamicListRefAgainstRef extends AbstractTestDynamicList<Byte>
{
  @Override protected Byte makeElement() {
    return (byte)rnd();
  }

  @Override protected List<Byte> makeTestee(final List<Byte> ref) {
    final List<Byte> res = new ArrayList<Byte>();
    for (final Byte b : ref) res.add(b);
    return res;
  }

  @Override protected List<Byte> makeRef() {
    final int size = rnd(200);
    final List<Byte> res = new ArrayList<Byte>();
    for (int i=0; i<size; i++) res.add(makeElement());
    return res;
  }

}
