/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.config.module.refresh;

import junit.framework.Assert;

import org.builtu.config.module.refresh.DailyRefreshStrategy;
import org.builtu.util.commutil.DateUtil;
import org.junit.Before;
import org.junit.Test;



public class TestDailyRefreshStrategy extends ClockedTestBase {
	
	private DailyRefreshStrategy strategy;
	
	@Before public void create() {
		strategy = new DailyRefreshStrategy();
		strategy.setClock(clock);
	}
	
	@Test public void testDay() {
		time = DateUtil.day(2009, 01, 01).getTime()+1000;
		strategy.refreshed();
		time += 1000;
		Assert.assertFalse(strategy.hasToBeRefreshed());
		time = DateUtil.day(2009, 01, 02).getTime();
		Assert.assertTrue(strategy.hasToBeRefreshed());
	}
	
	@Test public void testAtHour() {
		strategy.setAtHour(01);
		time = DateUtil.day(2009, 01, 01).getTime();
		strategy.refreshed();
		time = DateUtil.day(2009, 01, 02).getTime();
		Assert.assertFalse(strategy.hasToBeRefreshed());
		time += 24*60*60*1000;
		Assert.assertTrue(strategy.hasToBeRefreshed());
	}
}
