/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.persistence.logging;

import java.util.Map;
import java.util.Properties;

import org.apache.log4j.Logger;

public class HibernatePropertiesLoggerBean {
	
	private static final Logger log = Logger.getLogger(HibernatePropertiesLoggerBean.class);

	public void setHibernateProperties(final Properties hibernateProperties) {
		if (log.isInfoEnabled()) {
			log.info(formatProperties(hibernateProperties));
		}
	}
	
	public static String formatProperties(final Properties props) {
		final StringBuilder b = new StringBuilder();
		for (Map.Entry<Object, Object> entry : props.entrySet()) {
			b.append(format(entry.getKey()));
			b.append('=');
			b.append(format(entry.getValue()));
			b.append('\n');
		}
		return b.toString();
	}
	
	private static String format(final Object value) {
		if (value == null) return null;
		return value.toString().replace("\n", "\\\n");
	}
	
}
