/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.commutil;

import junit.framework.Assert;

import org.builtu.util.commutil.Util;
import org.junit.Test;


public class TestHexString {

	@Test public void testEmpty() {
		Assert.assertEquals("", Util.hexString(new byte[0]));
	}
	
	@Test public void test1() {
		Assert.assertEquals("01", Util.hexString(new byte[]{1}));
	}
	
	@Test public void testCAFE() {
		Assert.assertEquals("cafe", Util.hexString(new byte[]{(byte)0xca, (byte)0xfe}));
	}
	
	@Test public void test_1a66ff55() {
		Assert.assertEquals("1a66ff55", Util.hexString(new byte[]{(byte)0x1a, (byte)0x66, (byte)0xff, (byte)0x55}));
	}

	@Test public void testVkSign2() {
		final byte [] data = makeData (0xd6, 0xed, 0x0d, 0x13); 
		Assert.assertEquals("d6ed0d13", Util.hexString(data));
	}
	
	private static byte [] makeData (final int ... vals) {
		final byte [] res = new byte[vals.length];
		for(int i=0; i<vals.length; i++) res[i] = (byte) vals[i];
		return res;
	}
	
}
