/**
	This file is part of BUILTU.

    BUILTU is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BUILTU is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser Public License for more details.

    You should have received a copy of the GNU Lesser Public License
    along with BUILTU.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2005-2010 Pasko Boris
 */
package org.builtu.util.commutil;

import java.util.ArrayList;
import java.util.List;

import junit.framework.Assert;

import org.builtu.testing.BasicTestCase;
import org.builtu.util.commutil.Util;
import org.junit.Test;


public class TestUtilSerializeDeserialize extends BasicTestCase {
	
	@Test public void testRandomString() throws ClassNotFoundException {
		final String original = rndString();
		final String restored = (String) serdeser(original);
		Assert.assertEquals(original, restored);
	}
	
	@Test public void testRandomLong() throws ClassNotFoundException {
		final Long original = rndLong();
		final Long restored = (Long) serdeser(original);
		Assert.assertEquals(original, restored);
	}
	
	@Test public void testRandomList() throws ClassNotFoundException {
		final List<Object> original = new ArrayList<Object>();
		for (int i=0; i<rnd()%10; i++) {
			original.add(rndString());
		}
		for (int i=0; i<rnd()%10; i++) {
			original.add(rndLong());
		}
		for (int i=0; i<rnd()%10; i++) {
			original.add(rnd());
		}
		final List<?> restored = (List<?>) serdeser(original);
		Assert.assertEquals(original, restored);
	}

	private Object serdeser(final Object obj) throws ClassNotFoundException {
		final byte [] data = Util.serialize(obj);
		return Util.deserialize(data);
	}
	
}
